summaryrefslogtreecommitdiff
path: root/tests/mv/update
diff options
context:
space:
mode:
Diffstat (limited to 'tests/mv/update')
-rwxr-xr-xtests/mv/update71
1 files changed, 71 insertions, 0 deletions
diff --git a/tests/mv/update b/tests/mv/update
new file mode 100755
index 0000000..6bf161e
--- /dev/null
+++ b/tests/mv/update
@@ -0,0 +1,71 @@
+#!/bin/sh
+# make sure --update works as advertised
+
+# Copyright (C) 2001, 2004, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+ mv --version
+fi
+
+. $srcdir/../envvar-check
+. $srcdir/../lang-default
+
+pwd=`pwd`
+tmp=mv-update.$$
+trap 'status=$?; cd "$pwd" && rm -rf $tmp && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+echo old > old || framework_failure=1
+touch -d yesterday old || framework_failure=1
+echo new > new || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo 'failure in testing framework' 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+for cp_or_mv in cp mv; do
+ # This is a no-op.
+ $cp_or_mv --update old new || fail=1
+ case "`cat new`" in new) ;; *) fail=1 ;; esac
+ case "`cat old`" in old) ;; *) fail=1 ;; esac
+done
+
+# This will actually perform the rename.
+mv --update new old || fail=1
+test -f new && fail=1
+case "`cat old`" in new) ;; *) fail=1 ;; esac
+
+# Restore initial conditions.
+echo old > old || fail=1
+touch -d yesterday old || fail=1
+echo new > new || fail=1
+
+# This will actually perform the copy.
+cp --update new old || fail=1
+case "`cat old`" in new) ;; *) fail=1 ;; esac
+case "`cat new`" in new) ;; *) fail=1 ;; esac
+
+(exit $fail); exit $fail